#!/usr/bin/env python

"Test of elements and attribute interfaces."

import libxml2dom

d = libxml2dom.parseString("<ddd:doc xmlns:ddd='http://ddd'/>")
e = d.xpath("*")[0]
assert e.parentNode == d
assert e.namespaceURI == "http://ddd"
assert e.nodeName == e.tagName == "ddd:doc"
assert e.localName == "doc"
e.setAttributeNS("http://xxx", "xxx:x", "y")
assert e.getAttributeNS("http://xxx", "x") == "y"
l = e.xpath("@*")
assert len(l) == 1
a = l[0]
assert a.parentNode == e
assert a.namespaceURI == "http://xxx"
assert a.nodeName == "xxx:x"
assert a.localName == "x"
assert a.nodeValue == a.value == "y"
a2 = d.createAttributeNS("http://aaa", "aaa:a")
a2.nodeValue = "b"
assert a2.namespaceURI == "http://aaa"
assert a2.nodeName == "aaa:a"
assert a2.localName == "a"
assert a2.nodeValue == a2.value == "b"
e.setAttributeNodeNS(a2)
l2 = e.xpath("@*")
assert len(l2) == 2
e.setAttributeNS("http://ccc", "ccc:c", "d")
assert e.getAttributeNS("http://ccc", "c") == "d"
l3 = e.xpath("@*")
assert len(l3) == 3
e.setAttribute("p", "q")
assert e.getAttribute("p") == "q"
l4 = e.xpath("@*")
assert len(l4) == 4
print d.toString()

# vim: tabstop=4 expandtab shiftwidth=4
